
// Cairo_Preview_TestView.cpp : implementation of the CCairo_Preview_TestView class
//

#include "stdafx.h"
#include "Cairo_Preview_Test.h"

#include "Cairo_Preview_TestDoc.h"
#include "Cairo_Preview_TestView.h"

#include "cairo.h"
#include "cairo-win32.h"

#include <string.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CCairo_Preview_TestView

IMPLEMENT_DYNCREATE(CCairo_Preview_TestView, CView)

BEGIN_MESSAGE_MAP(CCairo_Preview_TestView, CView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CCairo_Preview_TestView::OnFilePrintPreview)
END_MESSAGE_MAP()

// CCairo_Preview_TestView construction/destruction

CCairo_Preview_TestView::CCairo_Preview_TestView()
{
	// TODO: add construction code here

}

CCairo_Preview_TestView::~CCairo_Preview_TestView()
{
}

BOOL CCairo_Preview_TestView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CCairo_Preview_TestView drawing
#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif

#define TEXT_SIZE 12
#define NUM_GLYPHS 65535

static cairo_status_t get_glyph (cairo_scaled_font_t *scaled_font,
	   const char *utf8,
	   cairo_glyph_t *glyph)
{
    cairo_glyph_t *text_to_glyphs;
    cairo_status_t status;
    int i;

    text_to_glyphs = glyph;
    i = 1;
    status = cairo_scaled_font_text_to_glyphs (scaled_font,
					       0, 0,
					       utf8, -1,
					       &text_to_glyphs, &i,
					       NULL, NULL,
					       0);
    if (status != CAIRO_STATUS_SUCCESS)
        return status;

    if (text_to_glyphs != glyph) {
	*glyph = text_to_glyphs[0];
	cairo_glyph_free (text_to_glyphs);
    }

    return CAIRO_STATUS_SUCCESS;
}

static void
draw (cairo_t *cr, int width, int height)
{
    cairo_glyph_t *glyphs = (cairo_glyph_t*)malloc (NUM_GLYPHS * sizeof (cairo_glyph_t));
    cairo_scaled_font_t *scaled_font;
    const char *characters[] = { /* try to exercise different widths of index */
   "D",
   "r",
   "a",
   "w",
   "n",
   " ",
   "W",
   "i",
   "t",
   "h",
   " ",
   "c",
   "a",
   "i",
   "r",
   "o",
   "_",
   "s",
   "h",
   "o",
   "w",
   "_",
   "g",
   "l",
	"y",
	"p",
	"h",
	"s",
	NULL,
    }, **utf8;

    cairo_status_t status;

    /* Paint white background. */
    cairo_save(cr);
    cairo_set_source_rgb (cr, 1, 1, 1);
    cairo_paint (cr);
    cairo_restore(cr);

    cairo_select_font_face (cr, "Sans",
			    CAIRO_FONT_SLANT_NORMAL,
			    CAIRO_FONT_WEIGHT_NORMAL);
    cairo_set_font_size (cr, TEXT_SIZE);
    scaled_font = cairo_get_scaled_font (cr);

    float offset = 0.0f;
    int ii = 0;
    for (utf8 = characters; *utf8 != NULL; utf8++) {
        status = get_glyph (scaled_font, *utf8, &glyphs[ii]);
	     if (status)
	         goto BAIL;

	      if (glyphs[ii].index) {
	          glyphs[ii].x = offset;
	          glyphs[ii].y = height - 1;
		           
		       offset += 10;
		   }
		   
		   ++ii;
    }

    cairo_show_glyphs (cr, glyphs, NUM_GLYPHS);

  BAIL:
    free(glyphs);

    return;
}

void CCairo_Preview_TestView::OnDraw(CDC* pDC)
{
	CCairo_Preview_TestDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	cairo_surface_t* surface = 0;
	if (pDC->IsPrinting () && !pDC->IsKindOf (RUNTIME_CLASS (CPreviewDC)))
      surface = cairo_win32_printing_surface_create(pDC->m_hDC);
	else
	   surface = cairo_win32_surface_create(pDC->m_hDC);

	cairo_t* cr = cairo_create(surface);

	draw(cr, 9, 11);
	
	// Arc test
	cairo_save(cr);
   double xc = 128.0;
   double yc = 128.0;
   double radius = 100.0;
   double angle1 = 45.0  * (M_PI/180.0);  // angles are specified
   double angle2 = 180.0 * (M_PI/180.0);  // in radians

   cairo_set_line_width (cr, 10.0);
   cairo_arc (cr, xc, yc, radius, angle1, angle2);
   cairo_stroke (cr);

   // draw helping lines
   cairo_set_source_rgba (cr, 1, 0.2, 0.2, 0.6);
   cairo_set_line_width (cr, 6.0);

   cairo_arc (cr, xc, yc, 10.0, 0, 2*M_PI);
   cairo_fill (cr);

   cairo_arc (cr, xc, yc, radius, angle1, angle1);
   cairo_line_to (cr, xc, yc);
   cairo_arc (cr, xc, yc, radius, angle2, angle2);
   cairo_line_to (cr, xc, yc);
   cairo_stroke (cr);
   cairo_restore(cr);
   
   // Draw 'Hello/void'
   cairo_save(cr);
   cairo_select_font_face (cr, "Sans", CAIRO_FONT_SLANT_NORMAL,
                                  CAIRO_FONT_WEIGHT_BOLD);
   cairo_set_font_size (cr, 90.0);

   cairo_move_to (cr, 10.0, 135.0);
   cairo_show_text (cr, "cairo_show_text");

   cairo_move_to (cr, 70.0, 165.0);
   cairo_text_path (cr, "cairo_text_path");
   cairo_set_source_rgb (cr, 0.5, 0.5, 1);
   cairo_fill_preserve (cr);
   cairo_set_source_rgb (cr, 0, 0, 0);
   cairo_set_line_width (cr, 2.56);
   cairo_stroke (cr);

   // draw helping lines
   cairo_set_source_rgba (cr, 1, 0.2, 0.2, 0.6);
   cairo_arc (cr, 10.0, 135.0, 5.12, 0, 2*M_PI);
   cairo_close_path (cr);
   cairo_arc (cr, 70.0, 165.0, 5.12, 0, 2*M_PI);
   cairo_fill (cr);
   cairo_restore(cr);
   /*
   cairo_text_extents_t extents;

   const char *utf8 = "cairo";

   cairo_select_font_face (cr, "Sans",
       CAIRO_FONT_SLANT_NORMAL,
       CAIRO_FONT_WEIGHT_NORMAL);

   cairo_set_font_size (cr, 52.0);
   cairo_text_extents (cr, utf8, &extents);
   double x = 300.0-(extents.width/2 + extents.x_bearing);
   double y = 300.0-(extents.height/2 + extents.y_bearing);

   cairo_move_to (cr, x, y);
   cairo_show_text (cr, utf8);

   // draw helping lines
   cairo_set_source_rgba (cr, 1, 0.2, 0.2, 0.6);
   cairo_set_line_width (cr, 6.0);
   cairo_arc (cr, x, y, 10.0, 0, 2*M_PI);
   cairo_fill (cr);
   cairo_move_to (cr, 300.0, 0);
   cairo_rel_line_to (cr, 0, 256);
   cairo_move_to (cr, 0, 300.0);
   cairo_rel_line_to (cr, 256, 0);
   cairo_stroke (cr);
   
   cairo_select_font_face (cr, "Sans",
       CAIRO_FONT_SLANT_NORMAL,
       CAIRO_FONT_WEIGHT_NORMAL);

   cairo_set_font_size (cr, 100.0);
   cairo_text_extents (cr, utf8, &extents);

   x=25.0;
   y=150.0;

   cairo_move_to (cr, x,y);
   cairo_show_text (cr, utf8);

   // draw helping lines
   cairo_set_source_rgba (cr, 1, 0.2, 0.2, 0.6);
   cairo_set_line_width (cr, 6.0);
   cairo_arc (cr, x, y, 10.0, 0, 2*M_PI);
   cairo_fill (cr);
   cairo_move_to (cr, x,y);
   cairo_rel_line_to (cr, 0, -extents.height);
   cairo_rel_line_to (cr, extents.width, 0);
   cairo_rel_line_to (cr, extents.x_bearing, -extents.y_bearing);
   cairo_stroke (cr);
   */   
	if (pDC->IsPrinting () && !pDC->IsKindOf (RUNTIME_CLASS (CPreviewDC)))
       cairo_show_page(cr);	   

   cairo_destroy(cr);
   cairo_surface_finish(surface);
}


// CCairo_Preview_TestView printing


void CCairo_Preview_TestView::OnFilePrintPreview()
{
	AFXPrintPreview(this);
}

BOOL CCairo_Preview_TestView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CCairo_Preview_TestView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CCairo_Preview_TestView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CCairo_Preview_TestView::OnRButtonUp(UINT nFlags, CPoint point)
{
	ClientToScreen(&point);
	OnContextMenu(this, point);
}

void CCairo_Preview_TestView::OnContextMenu(CWnd* pWnd, CPoint point)
{
	theApp.GetContextMenuManager()->ShowPopupMenu(IDR_POPUP_EDIT, point.x, point.y, this, TRUE);
}


// CCairo_Preview_TestView diagnostics

#ifdef _DEBUG
void CCairo_Preview_TestView::AssertValid() const
{
	CView::AssertValid();
}

void CCairo_Preview_TestView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CCairo_Preview_TestDoc* CCairo_Preview_TestView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CCairo_Preview_TestDoc)));
	return (CCairo_Preview_TestDoc*)m_pDocument;
}
#endif //_DEBUG


// CCairo_Preview_TestView message handlers
